<template>
  <div style="display: flex; justify-content: space-between;">
    <div>
      <select v-model="selectedMask" @click="updateMask()">
        <option>CLG</option>
        <option>DDG</option>
        <option>DLG</option>  
        <option>SHG</option>  
        <option>SNG</option>  
        <option>URG</option>  
        <option>VGG</option>  
        <option>WTG</option>  
        <option>SMG</option>  
      </select>
    </div>
    <div>
        <a href="#" @click.prevent="goToTask()">Задание</a>
    </div>
  </div>

  <div id="map_tile"></div>   

  <loader :active="loaderActive" message="Загрузка данных" />  

  <div v-for="item in images" v-bind:key="item.name">
    <div style="display: flex; justify-content: space-between;">
      <label>{{item.name}}</label>
      <div>
        <label style="font-weight:bold">Cloud</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label >{{item.Cloud}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Water</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Water}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Snow</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Snow}}</label>
      </div>
       <div>
        <label style="font-weight:bold">Defects</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Defects}}</label>
      </div>
      <div>
        <label style="font-weight:bold">DDefects</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.DDefects}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Shadows</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Shadows}}</label>
      </div>
      <div>
        <label style="font-weight:bold">StitchingMs</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.StitchingMs}}</label>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.productQualityStatus}}</a>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.routeQualityStatus}}</a>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.summaryQualityStatus}}</a>
      </div>
    </div>   
   
    <a rel="nofollow" :href="item.rpath">
      <img :src="item.rpath" style="width:100%;"/>
      <p></p>
    </a>
  </div>


</template>



<script>
import { defineComponent, reactive, ref } from "vue";
import axios from 'axios';
import {redouteProvider, tileProvider} from  "../config/provider.js"
import { loadYmap } from 'vue-yandex-maps'
import Loader from '../components/Loader.vue'
import router from "../router/index.ts"

// var map = null

function clearMap() {
  var el = document.getElementById("app");
  console.log('app = ' + el)
  el = document.getElementById("map_tile");
  console.log('map_tile = ' + el)
  if (el) {
    for (let elChild of el.childNodes) {
      elChild.remove()
    }
  }
}

let productId = null

export default defineComponent({ 
  name: "App",
  components: { Loader },

  async mounted() {
    clearMap()
  }, 

  setup() {

    const jobCrop = reactive([])
    const loaderActive = ref(true)    
       
    const url = new URL(window.location.href)
    const paramTaskId = url.searchParams.get("task_id")
    const paramJobId = url.searchParams.get("job_id")
    const paramProductId = url.searchParams.get("product_id")
    const taskId = paramTaskId ? paramTaskId : '' 
    const jobId = paramJobId ? paramJobId : '' 
    productId = paramProductId ? paramProductId : '' 
    let request = redouteProvider + '/job'

    let coords = reactive([])
    let coordsPolygon = reactive([])
    let crop = ref(false)
    let noCrop = ref("")
    const selectedMask = ref('CLG')

    showBorderAndTile(taskId, jobId, productId, loaderActive, selectedMask)

    let images = reactive([])
    request = redouteProvider + '/images'
    request = request + '?task_id=' + taskId + '&job_id=' + jobId + '&product_id=' + productId
    axios.get(request, {})
      .then(response => { 
        if (response.data && response.data.length > 0) {
          response.data.forEach(element => {
            element.rpath = redouteProvider+'/image?' + 'name=' + element.path
            element.qarpath = redouteProvider+'/file?' + 'name=' + element.qa
            images.push(element)
          })
        }
      })
      .catch(error => { 
        //table.messages.noDataAvailable = 'Сервер "' + request + '" не отвечает ' + error
        images.push({name:error})
      })

    function updateMask() {
      clearMap()
      showBorderAndTile(taskId, jobId, productId, loaderActive, selectedMask)
    }

    function goToTask() {
      // в каталог Л2 попадает маршрут из задания с параметром portal
      // здесь у нас есть product_id - по нему ищем id задания 
      // и переходим на страницу /task?task_id=<>

      let jsonData = {}
      jsonData['product_id'] = productId
      jsonData['portal'] = true

      let dataServer = redouteProvider + '/task'
      axios.post(dataServer, JSON.stringify(jsonData))
      .then(response => {
        let task_uid = null
        if (response.data && response.data.length > 0) {
          task_uid = response.data[0].task_uid
        }
        if (!task_uid) {
          confirm('Не найдено задание для ' + productId)
          return
        }
        router.push({ path: '/task', query: { uid: task_uid }} )
      })
      .catch(error => confirm('Сервер "' + dataServer + '" не отвечает ' + error))
    }


    return {
      images,
      coords,
      coordsPolygon,
      crop,
      noCrop,
      loaderActive,
      jobCrop,
      selectedMask,    
      updateMask,  
      goToTask,
    };
  },
});

async function showBorderAndTile(taskId, jobId, productId, loaderActive, selectedMask) {

  await loadYmap({
        apiKey: '',
        lang: 'ru_RU',
        coordorder: 'longlat',
        enterprise: false,
        version: '2.1'
    });

  let request = redouteProvider + '/crop' + '?task_id=' + taskId + '&job_id=' + jobId  + '&product_id=' + productId

  loaderActive.value = true;
  axios.get(request, {})
        .then(response => { 
          // могли не найти контур (например нет GBD.json в архиве Л2 Л0)
          if (response.data == null) {
            loaderActive.value = false;          
            return
          }
          // в первом элементе response.data[0] всегда хранится контур задания
          // в остальных контуры продуктов (сцен)
          let totalCrop = response.data.length
          let coords = []
          let jobCrop = []
          for (let i=0; i<totalCrop; i++)  {
            if (response.data[i].crop == null) {
              jobCrop.push({ crop: null })
              continue
            } 
            coords.push(...response.data[i].crop[0][0])
            let ar = []
            ar.push(response.data[i].crop[0])
            jobCrop.push({ name: response.data[i].name, crop: ar })
          }
          if (coords.length == 0) coords = [37.6155, 55.7522] // Москва
          if (jobCrop.length == 0) jobCrop.push({ name: 'Moscow', crop: [coords, coords, coords, coords, coords] })

          //if (!map)
          {
          var map = new window.ymaps.Map('map_tile', {
                  center: coords,
                  zoom: 8,
                  controls: ['typeSelector', 'fullscreenControl'],
            //      type: null // чтобы не загружался слой "Схема" Яндекс.Карт
              }, {
                // nativeFullscreen: true  
                // показывает на весь экран при нажатии на кнопку, 
                // но не работает при этом map.container.enterFullscreen()
              }); 
          }

          //var point = new window.YMaps.GeoPoint(37.609218,55.753559); // Координаты центра Москвы
          //map.setCenter(coords);
          
          //map.container.enterFullscreen();

          // первый шейп на задание (или null если не задано) - его сделаем красным потолще
          let taskCrop = jobCrop[0].crop
          if (taskCrop != null)  {
            let polygon = new window.ymaps.Polyline(
                  ...taskCrop,
                  { },
                  {
                    strokeWidth: 3,
                    strokeColor: '#FF0000',
                  });
            // Добавляем многоугольник на карту.
            map.geoObjects.add(polygon)
          }
          // остальные сделаем синими потоньше  
          for (let i=1; i<jobCrop.length; i++) {

            coords.length = 0;
            coords.push(...jobCrop[i].crop[0])

            let crop = jobCrop[i].crop  
            let name = jobCrop[i].name
            let polygon = new window.ymaps.Polygon(
                  crop,
                  { hintContent: name},
                  {
                    strokeWidth: 1,
                    strokeColor: '#0000FF',
                    fillOpacity:  0.0
                  });
            // Добавляем многоугольник на карту.
            map.geoObjects.add(polygon)
          }
          if (tileProvider) {
            let param = '/tile?hl=ru&%c' + '&task_id=' + taskId + '&job_id=' + jobId + '&product_id=' + productId
            var pmsLayer = new window.ymaps.Layer(tileProvider + param, {
                  projection: window.ymaps.projection.sphericalMercator, // указываем проекцию слоя OSM
                  tileTransparent: true
              });
            map.layers.add(pmsLayer);
          }
          let request = redouteProvider + '/mask' + '?task_id=' + taskId + '&job_id=' + jobId  + '&product_id=' + productId
          axios.post(request, JSON.stringify({ mask: selectedMask.value + '.json' } ))
          .then(response => { 
            let totalCrop = response.data.length
            let jobCrop = []
            for (let i=0; i<totalCrop; i++)  {
              let ar = []
              ar.push(response.data[i][0])
              jobCrop.push(ar)
            }
            // маски облаков сделаем желтыми и тонкими
            for (let crop of jobCrop) {
              let polygon = new window.ymaps.Polyline(
                  ...crop,
                  {},
                  {
                    strokeWidth: 2,
                    strokeColor: '#FFFF00',
                  });
                // Добавляем многоугольник на карту.
                map.geoObjects.add(polygon)
                }
            loaderActive.value = false;          
          })

        })
        .catch(error => { 
          alert(error)
          loaderActive.value = false;
        })
  }

</script>


<style scoped>

  :deep(.vtl-table td, .vtl-table th) {
    padding: 0.1rem;
    font-size: smaller;
  }

  :deep(.success) {
    color: green  
  }
  :deep(.error) {
    color: red
  }


  #map_tile {
      font-family: 'Avenir', Helvetica, Arial, sans-serif;
      -webkit-font-smoothing: antialiased;
      -moz-osx-font-smoothing: grayscale;
      text-align: center;
      color: #2c3e50;
      height: 600px;
      width:  auto; 
  }
  
</style>